Index: src/includes/classes/Smarty/Smarty.class.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/Smarty.class.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/Smarty.class.php	(revision )
@@ -974,72 +865,34 @@
      */
     public function setConfigDir($config_dir)
     {
-        $this->config_dir = array();
-        foreach ((array) $config_dir as $k => $v) {
-            $this->config_dir[$k] = preg_replace('#(\w+)(/|\\\\){1,}#', '$1$2', rtrim($v, '/\\')) . DS;
+        return $this->setTemplateDir($config_dir, true);
-        }
+    }
 
-        $this->joined_config_dir = join(DIRECTORY_SEPARATOR, $this->config_dir);
-
-        return $this;
-    }
-
     /**
      * Add config directory(s)
      *
-     * @param string|array        $config_dir directory(s) of config sources
+     * @param string|array $config_dir directory(s) of config sources
-     * @param mixed $key        key of the array element to assign the config dir to
+     * @param mixed        $key        key of the array element to assign the config dir to
      *
      * @return Smarty current Smarty instance for chaining
      */
     public function addConfigDir($config_dir, $key = null)
     {
-        // make sure we're dealing with an array
-        $this->config_dir = (array) $this->config_dir;
-
-        if (is_array($config_dir)) {
-            foreach ($config_dir as $k => $v) {
-                $v = preg_replace('#(\w+)(/|\\\\){1,}#', '$1$2', rtrim($v, '/\\')) . DS;
-                if (is_int($k)) {
-                    // indexes are not merged but appended
-                    $this->config_dir[] = $v;
-                } else {
-                    // string indexes are overridden
-                    $this->config_dir[$k] = $v;
+        return $this->addTemplateDir($config_dir, $key, true);
-                }
+    }
-            }
-        } else {
-            $v = preg_replace('#(\w+)(/|\\\\){1,}#', '$1$2', rtrim($config_dir, '/\\')) . DS;
-            if ($key !== null) {
-                // override directory at specified index
-                $this->config_dir[$key] = rtrim($v, '/\\') . DS;
-            } else {
-                // append new directory
-                $this->config_dir[] = rtrim($v, '/\\') . DS;
-            }
-        }
 
-        $this->joined_config_dir = join(DIRECTORY_SEPARATOR, $this->config_dir);
-
-        return $this;
-    }
-
     /**
      * Get config directory
      *
      * @param mixed $index index of directory to get, null to get all
      *
-     * @return array|string configuration directory
+     * @return array configuration directory
      */
     public function getConfigDir($index = null)
     {
-        if ($index !== null) {
-            return isset($this->config_dir[$index]) ? $this->config_dir[$index] : null;
+        return $this->getTemplateDir($index, true);
-        }
+    }
 
-        return (array) $this->config_dir;
-    }
-
     /**
      * Set plugins directory
      *
@@ -1049,11 +902,10 @@
      */
     public function setPluginsDir($plugins_dir)
     {
-        $this->plugins_dir = array();
-        foreach ((array) $plugins_dir as $k => $v) {
-            $this->plugins_dir[$k] = rtrim($v, '/\\') . DS;
+        $this->plugins_dir = (array) $plugins_dir;
+        if (isset($this->_cache['plugins_dir'])) {
+            unset($this->_cache['plugins_dir']);
         }
-
         return $this;
     }
 
@@ -1066,26 +918,13 @@
      */
     public function addPluginsDir($plugins_dir)
     {
-        // make sure we're dealing with an array
-        $this->plugins_dir = (array) $this->plugins_dir;
-
-        if (is_array($plugins_dir)) {
-            foreach ($plugins_dir as $k => $v) {
-                if (is_int($k)) {
-                    // indexes are not merged but appended
-                    $this->plugins_dir[] = rtrim($v, '/\\') . DS;
-                } else {
-                    // string indexes are overridden
-                    $this->plugins_dir[$k] = rtrim($v, '/\\') . DS;
+        if (!isset($this->plugins_dir)) {
+            $this->plugins_dir = array(SMARTY_PLUGINS_DIR);
-                }
+        }
+        $this->plugins_dir = array_merge((array) $this->plugins_dir, (array) $plugins_dir);
+        if (isset($this->_cache['plugins_dir'])) {
+            unset($this->_cache['plugins_dir']);
-            }
+        }
-        } else {
-            // append new directory
-            $this->plugins_dir[] = rtrim($plugins_dir, '/\\') . DS;
-        }
-
-        $this->plugins_dir = array_unique($this->plugins_dir);
-
         return $this;
     }
 
@@ -1096,8 +935,22 @@
      */
     public function getPluginsDir()
     {
-        return (array) $this->plugins_dir;
+        if (!isset($this->_cache['plugins_dir'])) {
+            if (!isset($this->plugins_dir)) {
+                $this->plugins_dir = array(SMARTY_PLUGINS_DIR);
+            } else {
+                $plugins_dir = (array) $this->plugins_dir;
+                $this->plugins_dir = array();
+                foreach ($plugins_dir as $v) {
+                    $this->plugins_dir[] = $this->_realpath($v . DS, true);
-    }
+                }
+                $this->plugins_dir = array_unique($this->plugins_dir);
+            }
+            $this->_cache['plugin_files'] = array();
+            $this->_cache['plugins_dir'] = true;
+        }
+        return $this->plugins_dir;
+    }
 
     /**
      * Set compile directory
@@ -1108,11 +961,11 @@
      */
     public function setCompileDir($compile_dir)
     {
-        $this->compile_dir = rtrim($compile_dir, '/\\') . DS;
+        $this->compile_dir = $this->_realpath($compile_dir . DS, true);
         if (!isset(Smarty::$_muted_directories[$this->compile_dir])) {
             Smarty::$_muted_directories[$this->compile_dir] = null;
         }
-
+        $this->_cache['compile_dir'] = true;
         return $this;
     }
 
@@ -1123,6 +976,13 @@
      */
     public function getCompileDir()
     {
+        if (!isset($this->_cache['compile_dir'])) {
+            $this->compile_dir = $this->_realpath($this->compile_dir . DS, true);
+            if (!isset(Smarty::$_muted_directories[$this->compile_dir])) {
+                Smarty::$_muted_directories[$this->compile_dir] = null;
+            }
+            $this->_cache['compile_dir'] = true;
+        }
         return $this->compile_dir;
     }
 
@@ -1135,11 +995,11 @@
      */
     public function setCacheDir($cache_dir)
     {
-        $this->cache_dir = rtrim($cache_dir, '/\\') . DS;
+        $this->cache_dir = $this->_realpath($cache_dir . DS, true);
         if (!isset(Smarty::$_muted_directories[$this->cache_dir])) {
             Smarty::$_muted_directories[$this->cache_dir] = null;
         }
-
+        $this->_cache['cache_dir'] = true;
         return $this;
     }
 
@@ -1150,144 +1010,50 @@
      */
     public function getCacheDir()
     {
-        return $this->cache_dir;
+        if (!isset($this->_cache['cache_dir'])) {
+            $this->cache_dir = $this->_realpath($this->cache_dir . DS, true);
+            if (!isset(Smarty::$_muted_directories[$this->cache_dir])) {
+                Smarty::$_muted_directories[$this->cache_dir] = null;
-    }
+            }
-
-    /**
-     * Set default modifiers
-     *
-     * @param  array|string $modifiers modifier or list of modifiers to set
-     *
-     * @return Smarty       current Smarty instance for chaining
-     */
-    public function setDefaultModifiers($modifiers)
-    {
-        $this->default_modifiers = (array) $modifiers;
-
-        return $this;
+            $this->_cache['cache_dir'] = true;
-    }
+        }
-
-    /**
-     * Add default modifiers
-     *
-     * @param  array|string $modifiers modifier or list of modifiers to add
-     *
-     * @return Smarty       current Smarty instance for chaining
-     */
-    public function addDefaultModifiers($modifiers)
-    {
-        if (is_array($modifiers)) {
-            $this->default_modifiers = array_merge($this->default_modifiers, $modifiers);
-        } else {
-            $this->default_modifiers[] = $modifiers;
+        return $this->cache_dir;
-        }
+    }
 
-        return $this;
-    }
-
     /**
-     * Get default modifiers
+     * add directories to given property name
      *
-     * @return array list of default modifiers
+     * @param string       $dirName directory property name
+     * @param string|array $dir     directory string or array of strings
+     * @param mixed        $key     optional key
      */
-    public function getDefaultModifiers()
+    private function _addDir($dirName, $dir, $key = null)
     {
-        return $this->default_modifiers;
-    }
-
-    /**
-     * Set autoload filters
-     *
-     * @param  array  $filters filters to load automatically
-     * @param  string $type    "pre", "output", … specify the filter type to set. Defaults to none treating $filters' keys as the appropriate types
-     *
-     * @return Smarty current Smarty instance for chaining
-     */
-    public function setAutoloadFilters($filters, $type = null)
-    {
-        if ($type !== null) {
-            $this->autoload_filters[$type] = (array) $filters;
+        $rp = $this->_cache[$dirName];
+        if (is_array($dir)) {
+            foreach ($dir as $k => $v) {
+                $path = $rp ? $this->_realpath($v . DS, true) : $v;
+                if (is_int($k)) {
+                    // indexes are not merged but appended
+                    $this->{$dirName}[] = $path;
-        } else {
+                } else {
-            $this->autoload_filters = (array) $filters;
+                    // string indexes are overridden
+                    $this->{$dirName}[$k] = $path;
-        }
+                }
-
-        return $this;
-    }
+            }
-
-    /**
-     * Add autoload filters
-     *
-     * @param  array  $filters filters to load automatically
-     * @param  string $type    "pre", "output", … specify the filter type to set. Defaults to none treating $filters' keys as the appropriate types
-     *
-     * @return Smarty current Smarty instance for chaining
-     */
-    public function addAutoloadFilters($filters, $type = null)
-    {
-        if ($type !== null) {
-            if (!empty($this->autoload_filters[$type])) {
-                $this->autoload_filters[$type] = array_merge($this->autoload_filters[$type], (array) $filters);
-            } else {
+        } else {
-                $this->autoload_filters[$type] = (array) $filters;
-            }
+            $path = $rp ? $this->_realpath($dir . DS, true) : $dir;
+            if ($key !== null) {
+                // override directory at specified index
+                $this->{$dirName}[$key] = $path;
-        } else {
+            } else {
-            foreach ((array) $filters as $key => $value) {
-                if (!empty($this->autoload_filters[$key])) {
-                    $this->autoload_filters[$key] = array_merge($this->autoload_filters[$key], (array) $value);
-                } else {
-                    $this->autoload_filters[$key] = (array) $value;
+                // append new directory
+                $this->{$dirName}[] = $path;
-                }
-            }
-        }
+            }
+        }
+    }
 
-        return $this;
-    }
-
     /**
-     * Get autoload filters
-     *
-     * @param  string $type type of filter to get autoloads for. Defaults to all autoload filters
-     *
-     * @return array  array( 'type1' => array( 'filter1', 'filter2', … ) ) or array( 'filter1', 'filter2', …) if $type was specified
-     */
-    public function getAutoloadFilters($type = null)
-    {
-        if ($type !== null) {
-            return isset($this->autoload_filters[$type]) ? $this->autoload_filters[$type] : array();
-        }
-
-        return $this->autoload_filters;
-    }
-
-    /**
-     * return name of debugging template
-     *
-     * @return string
-     */
-    public function getDebugTemplate()
-    {
-        return $this->debug_tpl;
-    }
-
-    /**
-     * set the debug template
-     *
-     * @param  string $tpl_name
-     *
-     * @return Smarty          current Smarty instance for chaining
-     * @throws SmartyException if file is not readable
-     */
-    public function setDebugTemplate($tpl_name)
-    {
-        if (!is_readable($tpl_name)) {
-            throw new SmartyException("Unknown file '{$tpl_name}'");
-        }
-        $this->debug_tpl = $tpl_name;
-
-        return $this;
-    }
-
-    /**
      * creates a template object
      *
      * @param  string  $template   the resource handle of the template file
@@ -1300,8 +1066,8 @@
      */
     public function createTemplate($template, $cache_id = null, $compile_id = null, $parent = null, $do_clone = true)
     {
-	    $template = $this->_getGambioUsermodFilePath($template);
-	    
+        $template = $this->_getGambioUsermodFilePath($template);
+        
         if ($cache_id !== null && (is_object($cache_id) || is_array($cache_id))) {
             $parent = $cache_id;
             $cache_id = null;
@@ -1312,48 +1078,36 @@
         } else {
             $data = null;
         }
-        // default to cache_id and compile_id of Smarty object
-        $cache_id = $cache_id === null ? $this->cache_id : $cache_id;
-        $compile_id = $compile_id === null ? $this->compile_id : $compile_id;
-        // already in template cache?
-        if ($this->allow_ambiguous_resources) {
-            $_templateId = Smarty_Resource::getUniqueTemplateName($this, $template) . $cache_id . $compile_id;
-        } else {
-            $_templateId = $this->joined_template_dir . '#' . $template . $cache_id . $compile_id;
-        }
-        if (isset($_templateId[150])) {
-            $_templateId = sha1($_templateId);
-        }
-        if ($do_clone) {
-            if (isset($this->template_objects[$_templateId])) {
-                // return cached template object
-                $tpl = clone $this->template_objects[$_templateId];
-                $tpl->smarty = clone $tpl->smarty;
+        if ($this->caching &&
+            isset($this->_cache['isCached'][$_templateId = $this->_getTemplateId($template, $cache_id, $compile_id)])
+        ) {
+            $tpl = $do_clone ? clone $this->_cache['isCached'][$_templateId] : $this->_cache['isCached'][$_templateId];
-                $tpl->parent = $parent;
-                $tpl->tpl_vars = array();
-                $tpl->config_vars = array();
-            } else {
+            $tpl->parent = $parent;
+            $tpl->tpl_vars = array();
+            $tpl->config_vars = array();
+        } else {
-                $tpl = new $this->template_class($template, clone $this, $parent, $cache_id, $compile_id);
+            /* @var Smarty_Internal_Template $tpl */
+            $tpl = new $this->template_class($template, $this, $parent, $cache_id, $compile_id, null, null);
-            }
+        }
-        } else {
-            if (isset($this->template_objects[$_templateId])) {
-                // return cached template object
-                $tpl = $this->template_objects[$_templateId];
-                $tpl->parent = $parent;
-                $tpl->tpl_vars = array();
-                $tpl->config_vars = array();
-            } else {
-                $tpl = new $this->template_class($template, $this, $parent, $cache_id, $compile_id);
+        if ($do_clone) {
+            $tpl->smarty = clone $tpl->smarty;
+        } elseif ($parent === null) {
+            $tpl->parent = $this;
-            }
+        }
-        }
         // fill data if present
         if (!empty($data) && is_array($data)) {
             // set up variable values
             foreach ($data as $_key => $_val) {
-                $tpl->tpl_vars[$_key] = new Smarty_variable($_val);
+                $tpl->tpl_vars[$_key] = new Smarty_Variable($_val);
             }
         }
-
+        if ($this->debugging || $this->debugging_ctrl == 'URL') {
+            $tpl->smarty->_debug = new Smarty_Internal_Debug();
+            // check URL debugging control
+            if (!$this->debugging && $this->debugging_ctrl == 'URL') {
+                $tpl->smarty->_debug->debugUrl($tpl->smarty);
+            }
+        }
         return $tpl;
     }
 
@@ -1370,130 +1124,265 @@
      */
     public function loadPlugin($plugin_name, $check = true)
     {
-        // if function or class exists, exit silently (already loaded)
-        if ($check && (is_callable($plugin_name) || class_exists($plugin_name, false))) {
-            return true;
+        return $this->ext->loadPlugin->loadPlugin($this, $plugin_name, $check);
-        }
+    }
-        // Plugin name is expected to be: Smarty_[Type]_[Name]
-        $_name_parts = explode('_', $plugin_name, 3);
-        // class name must have three parts to be valid plugin
-        // count($_name_parts) < 3 === !isset($_name_parts[2])
-        if (!isset($_name_parts[2]) || strtolower($_name_parts[0]) !== 'smarty') {
-            throw new SmartyException("plugin {$plugin_name} is not a valid name format");
-        }
-        // if type is "internal", get plugin from sysplugins
-        if (strtolower($_name_parts[1]) == 'internal') {
-            $file = SMARTY_SYSPLUGINS_DIR . strtolower($plugin_name) . '.php';
-            if (isset(self::$_is_file_cache[$file]) ? self::$_is_file_cache[$file] : self::$_is_file_cache[$file] = is_file($file)) {
-                require_once($file);
-                return $file;
+
+    /**
+     * Get unique template id
+     *
+     * @param string     $template_name
+     * @param null|mixed $cache_id
+     * @param null|mixed $compile_id
+     * @param null       $caching
+     *
+     * @return string
+     */
+    public function _getTemplateId($template_name, $cache_id = null, $compile_id = null, $caching = null)
+    {
+        $cache_id = $cache_id === null ? $this->cache_id : $cache_id;
+        $compile_id = $compile_id === null ? $this->compile_id : $compile_id;
+        $caching = (int) ($caching === null ? $this->caching : $caching);
+
+        if ($this->allow_ambiguous_resources) {
+            $_templateId =
+                Smarty_Resource::getUniqueTemplateName($this, $template_name) . "#{$cache_id}#{$compile_id}#{$caching}";
-            } else {
+        } else {
-                return false;
+            $_templateId = $this->_joined_template_dir . "#{$template_name}#{$cache_id}#{$compile_id}#{$caching}";
-            }
+        }
+        if (isset($_templateId[150])) {
+            $_templateId = sha1($_templateId);
         }
-        // plugin filename is expected to be: [type].[name].php
-        $_plugin_filename = "{$_name_parts[1]}.{$_name_parts[2]}.php";
+        return $_templateId;
+    }
 
-        $_stream_resolve_include_path = function_exists('stream_resolve_include_path');
+    /**
+     * Normalize path
+     *  - remove /./ and /../
+     *  - make it absolute if required
+     *
+     * @param string $path     file path
+     * @param bool   $realpath leave $path relative
+     *
+     * @return string
+     */
+    public function _realpath($path, $realpath = null)
+    {
+        static $pattern = null;
+        static $nds = null;
+        if ($pattern == null) {
+            $nds = DS == '/' ? '\\' : '/';
+            $ds = '\\' . DS;
+            $pattern =
+                "#([{$ds}]+[^{$ds}]+[{$ds}]+[.]([{$ds}]+[.])*[.][{$ds}]+([.][{$ds}]+)*)|([{$ds}]+([.][{$ds}]+)+)|[{$ds}]{2,}#";
+        }
+        // normalize DS
+        if (strpos($path, $nds) !== false) {
+            $path = str_replace($nds, DS, $path);
+        }
 
-        // loop through plugin dirs and find the plugin
-        foreach ($this->getPluginsDir() as $_plugin_dir) {
-            $names = array(
-                $_plugin_dir . $_plugin_filename,
-                $_plugin_dir . strtolower($_plugin_filename),
-            );
-            foreach ($names as $file) {
-                if (isset(self::$_is_file_cache[$file]) ? self::$_is_file_cache[$file] : self::$_is_file_cache[$file] = is_file($file)) {
-                    require_once($file);
-                    return $file;
+        if ($realpath === true && (($path[0] !== '/' && DS == '/') || ($path[1] !== ':' && DS != '/'))) {
+            $path = getcwd() . DS . $path;
-                }
+        }
-                if ($this->use_include_path && !preg_match('/^([\/\\\\]|[a-zA-Z]:[\/\\\\])/', $_plugin_dir)) {
-                    // try PHP include_path
-                    if ($_stream_resolve_include_path) {
-                        $file = stream_resolve_include_path($file);
-                    } else {
-                        $file = Smarty_Internal_Get_Include_Path::getIncludePath($file);
+        while ((strpos($path, '.' . DS) !== false) || (strpos($path, DS . DS) !== false)) {
+            $path = preg_replace($pattern, DS, $path);
-                    }
+        }
+        if ($realpath === false && ($path[0] == '/' || $path[1] == ':')) {
+            $path = str_ireplace(getcwd(), '.', $path);
+        }
+        return $path;
+    }
 
-                    if ($file !== false) {
-                        require_once($file);
+    /**
+     * @param boolean $compile_check
+     */
+    public function setCompileCheck($compile_check)
+    {
+        $this->compile_check = $compile_check;
+    }
 
-                        return $file;
+    /**
+     * @param boolean $use_sub_dirs
+     */
+    public function setUseSubDirs($use_sub_dirs)
+    {
+        $this->use_sub_dirs = $use_sub_dirs;
-                    }
+    }
+
+    /**
+     * @param int $error_reporting
+     */
+    public function setErrorReporting($error_reporting)
+    {
+        $this->error_reporting = $error_reporting;
-                }
+    }
+
+    /**
+     * @param boolean $escape_html
+     */
+    public function setEscapeHtml($escape_html)
+    {
+        $this->escape_html = $escape_html;
-            }
+    }
+
+    /**
+     * @param boolean $auto_literal
+     */
+    public function setAutoLiteral($auto_literal)
+    {
+        $this->auto_literal = $auto_literal;
-        }
+    }
-        // no plugin loaded
-        return false;
+
+    /**
+     * @param boolean $force_compile
+     */
+    public function setForceCompile($force_compile)
+    {
+        $this->force_compile = $force_compile;
     }
 
     /**
-     * Compile all template files
-     *
-     * @param  string $extension     file extension
-     * @param  bool   $force_compile force all to recompile
-     * @param  int    $time_limit
-     * @param  int    $max_errors
-     *
-     * @return integer number of template files recompiled
+     * @param boolean $merge_compiled_includes
      */
-    public function compileAllTemplates($extension = '.tpl', $force_compile = false, $time_limit = 0, $max_errors = null)
+    public function setMergeCompiledIncludes($merge_compiled_includes)
     {
-        return Smarty_Internal_Utility::compileAllTemplates($extension, $force_compile, $time_limit, $max_errors, $this);
+        $this->merge_compiled_includes = $merge_compiled_includes;
     }
 
     /**
-     * Compile all config files
-     *
-     * @param  string $extension     file extension
-     * @param  bool   $force_compile force all to recompile
-     * @param  int    $time_limit
-     * @param  int    $max_errors
-     *
-     * @return integer number of template files recompiled
+     * @param string $left_delimiter
      */
-    public function compileAllConfig($extension = '.conf', $force_compile = false, $time_limit = 0, $max_errors = null)
+    public function setLeftDelimiter($left_delimiter)
     {
-        return Smarty_Internal_Utility::compileAllConfig($extension, $force_compile, $time_limit, $max_errors, $this);
+        $this->left_delimiter = $left_delimiter;
     }
 
     /**
-     * Delete compiled template file
+     * @param string $right_delimiter
+     */
+    public function setRightDelimiter($right_delimiter)
+    {
+        $this->right_delimiter = $right_delimiter;
+    }
+
+    /**
+     * @param boolean $debugging
+     */
+    public function setDebugging($debugging)
+    {
+        $this->debugging = $debugging;
+    }
+
+    /**
+     * @param boolean $config_overwrite
+     */
+    public function setConfigOverwrite($config_overwrite)
+    {
+        $this->config_overwrite = $config_overwrite;
+    }
+
+    /**
+     * @param boolean $config_booleanize
+     */
+    public function setConfigBooleanize($config_booleanize)
+    {
+        $this->config_booleanize = $config_booleanize;
+    }
+
+    /**
+     * @param boolean $config_read_hidden
+     */
+    public function setConfigReadHidden($config_read_hidden)
+    {
+        $this->config_read_hidden = $config_read_hidden;
+    }
+
+    /**
+     * @param boolean $compile_locking
+     */
+    public function setCompileLocking($compile_locking)
+    {
+        $this->compile_locking = $compile_locking;
+    }
+
+    /**
+     * @param string $default_resource_type
+     */
+    public function setDefaultResourceType($default_resource_type)
+    {
+        $this->default_resource_type = $default_resource_type;
+    }
+
+    /**
+     * @param string $caching_type
+     */
+    public function setCachingType($caching_type)
+    {
+        $this->caching_type = $caching_type;
+    }
+
+    /**
+     * Test install
      *
-     * @param  string  $resource_name template name
-     * @param  string  $compile_id    compile id
-     * @param  integer $exp_time      expiration time
-     *
-     * @return integer number of template files deleted
+     * @param null $errors
      */
-    public function clearCompiledTemplate($resource_name = null, $compile_id = null, $exp_time = null)
+    public function testInstall(&$errors = null)
     {
-        return Smarty_Internal_Utility::clearCompiledTemplate($resource_name, $compile_id, $exp_time, $this);
+        Smarty_Internal_TestInstall::testInstall($this, $errors);
     }
 
     /**
-     * Return array of tag/attributes of all tags used by an template
+     * Class destructor
+     */
+    public function __destruct()
+    {
+        $i = 0;// intentionally left blank
+    }
+
+    /**
+     * <<magic>> Generic getter.
+     * Calls the appropriate getter function.
+     * Issues an E_USER_NOTICE if no valid getter is found.
      *
-     * @param Smarty_Internal_Template $template
+     * @param  string $name property name
      *
-     * @return array  of tag/attributes
+     * @return mixed
      */
-    public function getTags(Smarty_Internal_Template $template)
+    public function __get($name)
     {
-        return Smarty_Internal_Utility::getTags($template);
+
+        if (isset(self::$accessMap[$name])) {
+            $method = 'get' . self::$accessMap[$name];
+            return $this->{$method}();
+        } elseif (in_array($name, self::$obsoleteProperties)) {
+            return null;
+        } else {
+            trigger_error('Undefined property: ' . get_class($this) . '::$' . $name, E_USER_NOTICE);
-    }
+        }
+    }
 
     /**
-     * Run installation test
+     * <<magic>> Generic setter.
+     * Calls the appropriate setter function.
+     * Issues an E_USER_NOTICE if no valid setter is found.
      *
-     * @param  array $errors Array to write errors into, rather than outputting them
-     *
-     * @return boolean true if setup is fine, false if something is wrong
+     * @param string $name  property name
+     * @param mixed  $value parameter passed to setter
      */
-    public function testInstall(&$errors = null)
+    public function __set($name, $value)
     {
-        return Smarty_Internal_Utility::testInstall($this, $errors);
+        if (isset(self::$accessMap[$name])) {
+            $method = 'set' . self::$accessMap[$name];
+            $this->{$method}($value);
+        } elseif (in_array($name, self::$obsoleteProperties)) {
+            return;
+        } else {
+            if (is_object($value) && method_exists($value, $name)) {
+                $this->$name = $value;
+            } else {
+                trigger_error('Undefined property: ' . get_class($this) . '::$' . $name, E_USER_NOTICE);
-    }
+            }
+        }
+    }
 
     /**
      * Error Handler to mute expected messages
@@ -1516,10 +1405,8 @@
         if (!isset(Smarty::$_muted_directories[SMARTY_DIR])) {
             $smarty_dir = realpath(SMARTY_DIR);
             if ($smarty_dir !== false) {
-                Smarty::$_muted_directories[SMARTY_DIR] = array(
-                    'file'   => $smarty_dir,
-                    'length' => strlen($smarty_dir),
-                );
+                Smarty::$_muted_directories[SMARTY_DIR] =
+                    array('file' => $smarty_dir, 'length' => strlen($smarty_dir),);
             }
         }
 
@@ -1533,10 +1420,7 @@
                     unset(Smarty::$_muted_directories[$key]);
                     continue;
                 }
-                $dir = array(
-                    'file'   => $file,
-                    'length' => strlen($file),
-                );
+                $dir = array('file' => $file, 'length' => strlen($file),);
             }
             if (!strncmp($errfile, $dir['file'], $dir['length'])) {
                 $_is_muted_directory = true;
@@ -1548,7 +1432,8 @@
         // or the error was within smarty but masked to be ignored
         if (!$_is_muted_directory || ($errno && $errno & error_reporting())) {
             if (Smarty::$_previous_error_handler) {
-                return call_user_func(Smarty::$_previous_error_handler, $errno, $errstr, $errfile, $errline, $errcontext);
+                return call_user_func(Smarty::$_previous_error_handler, $errno, $errstr, $errfile, $errline,
+                                      $errcontext);
             } else {
                 return false;
             }
